package applet;
/*#################################################################################################
#######################################Licensing###################################################
###################################################################################################
This programm is licensed as Creative Commons Attribution Non-Commercial Share Alike.
If you want to use it to make money, please send me a PM:
http://www.mikrocontroller.net/user/show/nitnelav
###################################################################################################
###################################################################################################
###################################################################################################
 */



import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JSpinner;
import javax.swing.SpinnerNumberModel;


public class ATC extends JFrame{
	//Links
	JButton cc_scl = new JButton("<html><font color=\"#0000CF\"><u>calculate</u></font></html>");
	JButton cc_prsc = new JButton("<html><font color=\"#0000CF\"><u>calculate</u></font></html>");
	JButton cc_ocr = new JButton("<html><font color=\"#0000CF\"><u>calculate</u></font></html>");
	JButton cc_ctcf = new JButton("<html><font color=\"#0000CF\"><u>calculate</u></font></html>");
	
	//Entryfields
	JComboBox sysclock = new JComboBox();
	JComboBox prescale = new JComboBox();
	JSpinner OCR = new JSpinner(new SpinnerNumberModel(255, 0, 1000000000, 1));
	JSpinner CTC_f = new JSpinner(new SpinnerNumberModel(1.d, 0.d, 1000000000.d, 1.d));
	JCheckBox cbPinToggle = new JCheckBox("<html>Pin toggle instead<br>of interrupt</html>");
	
	public ATC(){
		setTitle("AVRTimerCalculator");
		setDefaultCloseOperation(EXIT_ON_CLOSE);
		setLayout(new GridLayout(5,3,10,10));
		
		//SystemClock
		add(new JLabel("System Clock"));
		
		add(sysclock);
		sysclock.setEditable(true);
		sysclock.addItem(32768);
		sysclock.addItem(1000000);
		sysclock.addItem(3686400);
		sysclock.addItem(4000000);
		sysclock.addItem(8000000);
		
		add(cc_scl);
		cc_scl.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				calc_Systemclock();
			}});
		
		
		//Prescaler
		
		add(new JLabel("Prescaler"));
		
		add(prescale);
		prescale.setEditable(true);
		prescale.addItem(1);
		prescale.addItem(8);
		prescale.addItem(64);
		prescale.addItem(256);
		prescale.addItem(1024);
		
		add(cc_prsc);
		cc_prsc.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				calc_Prescaler();
			}});
		
		
		//OCRnA
		
		add(new JLabel("OCRnA"));
		
		add(OCR);
		
		add(cc_ocr);
		cc_ocr.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				calc_OCR();
			}});
		
		
		//CTC-Frequency
		
		add(new JLabel("CTC Frequency"));
		
		add(CTC_f);
		
		add(cc_ctcf);
		cc_ctcf.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				calc_CTCf();
			}});
		
		//Pin toggle and interrupt and the great maker of the whole thing
		
		add(cbPinToggle);
		
		add(new JLabel());//Empty JLabel used as gap
		
		
		add(new JLabel("<html><font color=\"#777777\">by Valentin Buck</font></html>"));//See Creative Commons: By
	}
	
	void calc_Systemclock(){
		try{
         double CTC =  (Double) CTC_f.getValue();
         double prescaler = Double.valueOf(String.valueOf(prescale.getSelectedItem()));
         double SC = Double.valueOf(String.valueOf(sysclock.getSelectedItem()));
         double OCRn =  Double.valueOf(String.valueOf(OCR.getValue()));
         if( cbPinToggle.isSelected()){
             prescaler = prescaler * 2;
         }
         SC = CTC * (prescaler * (1 + OCRn));//See datasheet

         sysclock.addItem(SC);
         sysclock.setSelectedItem(SC);
		}
		catch(Exception ex){
			System.out.println( "Fatal Error");
     	}
		
	}
	
	void calc_Prescaler(){
		try{
			 double CTC =  (Double) CTC_f.getValue();
	         double prescaler = Double.valueOf(String.valueOf(prescale.getSelectedItem()));
	         double SC = Double.valueOf(String.valueOf(sysclock.getSelectedItem()));
	         double OCRn =  Double.valueOf(String.valueOf(OCR.getValue()));
	         if( cbPinToggle.isSelected()){
	             prescaler = prescaler * 2;
	         }
	         prescaler = SC / (CTC * (1 + OCRn));//See datasheet

	         prescale.addItem(prescaler);
	         sysclock.setSelectedItem(SC);
		}
        catch(Exception ex){
        	System.out.println( "Fatal Error");
        }
		
	}
	
	void calc_OCR(){
		try{
		 double CTC =  (Double) CTC_f.getValue();
         double prescaler = Double.valueOf(String.valueOf(prescale.getSelectedItem()));
         double SC = Double.valueOf(String.valueOf(sysclock.getSelectedItem()));
         double OCRn =  Double.valueOf(String.valueOf(OCR.getValue()));
         if( cbPinToggle.isSelected()){
             prescaler = prescaler * 2;
         }
            OCRn = (SC / (prescaler * CTC)) - 1;//See datasheet

            OCR.setValue(OCRn);
	}
            catch(Exception ex){
            	System.out.println( "Fatal Error");
            }
		
	}
	
	void calc_CTCf(){
		try{
			 double CTC =  (Double) CTC_f.getValue();
	         double prescaler = Double.valueOf(String.valueOf(prescale.getSelectedItem()));
	         double SC = Double.valueOf(String.valueOf(sysclock.getSelectedItem()));
	         double OCRn =  Double.valueOf(String.valueOf(OCR.getValue()));
	         if( cbPinToggle.isSelected()){
	             prescaler = prescaler * 2;
	         }
	         
	         CTC = SC / (prescaler * (1 + OCRn));//See Datasheet

	         CTC_f.setValue( CTC);
		}
		catch(Exception ex){
        	System.out.println( "Fatal Error");
        }
	}
	
	private static final long serialVersionUID = -8427426255588621306L;

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		ATC gui = new ATC();
		gui.setBounds(50, 50, 420, 300);
		gui.setVisible(true);
		
	}

}
