package applet;
/*#################################################################################################
#######################################Licensing###################################################
###################################################################################################
This programm is licensed as Creative Commons Attribution Non-Commercial Share Alike.
If you want to use it to make money, please send me a PM:
http://www.mikrocontroller.net/user/show/nitnelav
###################################################################################################
###################################################################################################
###################################################################################################
 */

import java.awt.Container;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JApplet;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JSpinner;
import javax.swing.SpinnerNumberModel;

public class ATC_Applet extends JApplet {
  //Links
  JButton cc_scl = new JButton("<html><font color=\"#0000CF\"><u>calculate</u></font></html>");

  JButton cc_prsc = new JButton("<html><font color=\"#0000CF\"><u>calculate</u></font></html>");

  JButton cc_ocr = new JButton("<html><font color=\"#0000CF\"><u>calculate</u></font></html>");

  JButton cc_ctcf = new JButton("<html><font color=\"#0000CF\"><u>calculate</u></font></html>");

  //Entryfields
  JComboBox sysclock = new JComboBox();

  JComboBox prescale = new JComboBox();

  JSpinner OCR = new JSpinner(new SpinnerNumberModel(255, 0, 1000000000, 1));

  JSpinner CTC_f = new JSpinner(new SpinnerNumberModel(1.d, 0.d, 1000000000.d, 1.d));

  JCheckBox cbPinToggle = new JCheckBox("<html>Pin toggle instead<br>of interrupt</html>");

  /**
   * 
   */
  public ATC_Applet() {
    Container c = getContentPane();
    c.setLayout(new GridLayout(5, 3, 10, 10));

    //SystemClock
    c.add(new JLabel("System Clock"));

    c.add(sysclock);
    sysclock.setEditable(true);
    sysclock.addItem(32768);
    sysclock.addItem(1000000);
    sysclock.addItem(3686400);
    sysclock.addItem(4000000);
    sysclock.addItem(8000000);

    c.add(cc_scl);
    cc_scl.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        calc_Systemclock();
      }
    });

    //Prescaler

    c.add(new JLabel("Prescaler"));

    c.add(prescale);
    prescale.setEditable(true);
    prescale.addItem(1);
    prescale.addItem(8);
    prescale.addItem(64);
    prescale.addItem(256);
    prescale.addItem(1024);

    c.add(cc_prsc);
    cc_prsc.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        calc_Prescaler();
      }
    });

    //OCRnA

    c.add(new JLabel("OCRnA"));

    c.add(OCR);

    c.add(cc_ocr);
    cc_ocr.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        calc_OCR();
      }
    });

    //CTC-Frequency

    c.add(new JLabel("CTC Frequency"));

    c.add(CTC_f);

    c.add(cc_ctcf);
    cc_ctcf.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        calc_CTCf();
      }
    });

    //Pin toggle and interrupt and the great maker of the whole thing

    c.add(cbPinToggle);

    c.add(new JLabel());//Empty JLabel used as gap

    c.add(new JLabel("<html><font color=\"#777777\">by Valentin Buck</font></html>"));//See Creative Commons: By
  }

  void calc_Systemclock() {
    try {
      double CTC = (Double) CTC_f.getValue();
      double prescaler = Double.valueOf(String.valueOf(prescale.getSelectedItem()));
      double SC = Double.valueOf(String.valueOf(sysclock.getSelectedItem()));
      double OCRn = Double.valueOf(String.valueOf(OCR.getValue()));
      if (cbPinToggle.isSelected()) {
        prescaler = prescaler * 2;
      }
      SC = CTC * (prescaler * (1 + OCRn));//See datasheet

      sysclock.addItem(SC);
      sysclock.setSelectedItem(SC);
    } catch (Exception ex) {
      System.out.println("Fatal Error");
    }

  }

  void calc_Prescaler() {
    try {
      double CTC = (Double) CTC_f.getValue();
      double prescaler = Double.valueOf(String.valueOf(prescale.getSelectedItem()));
      double SC = Double.valueOf(String.valueOf(sysclock.getSelectedItem()));
      double OCRn = Double.valueOf(String.valueOf(OCR.getValue()));
      if (cbPinToggle.isSelected()) {
        prescaler = prescaler * 2;
      }
      prescaler = SC / (CTC * (1 + OCRn));//See datasheet

      prescale.addItem(prescaler);
      sysclock.setSelectedItem(SC);
    } catch (Exception ex) {
      System.out.println("Fatal Error");
    }

  }

  void calc_OCR() {
    try {
      double CTC = (Double) CTC_f.getValue();
      double prescaler = Double.valueOf(String.valueOf(prescale.getSelectedItem()));
      double SC = Double.valueOf(String.valueOf(sysclock.getSelectedItem()));
      double OCRn = Double.valueOf(String.valueOf(OCR.getValue()));
      if (cbPinToggle.isSelected()) {
        prescaler = prescaler * 2;
      }
      OCRn = (SC / (prescaler * CTC)) - 1;//See datasheet

      OCR.setValue(OCRn);
    } catch (Exception ex) {
      System.out.println("Fatal Error");
    }

  }

  void calc_CTCf() {
    try {
      double CTC = (Double) CTC_f.getValue();
      double prescaler = Double.valueOf(String.valueOf(prescale.getSelectedItem()));
      double SC = Double.valueOf(String.valueOf(sysclock.getSelectedItem()));
      double OCRn = Double.valueOf(String.valueOf(OCR.getValue()));
      if (cbPinToggle.isSelected()) {
        prescaler = prescaler * 2;
      }

      CTC = SC / (prescaler * (1 + OCRn));//See Datasheet

      CTC_f.setValue(CTC);
    } catch (Exception ex) {
      System.out.println("Fatal Error");
    }
  }

  private static final long serialVersionUID = -8427426255588621306L;

}